
;CodeVisionAVR C Compiler V2.05.0 Professional
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega328P
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Size
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: No
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega328P
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2303
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU EECR=0x1F
	.EQU EEDR=0x20
	.EQU EEARL=0x21
	.EQU EEARH=0x22
	.EQU SPSR=0x2D
	.EQU SPDR=0x2E
	.EQU SMCR=0x33
	.EQU MCUSR=0x34
	.EQU MCUCR=0x35
	.EQU WDTCSR=0x60
	.EQU UCSR0A=0xC0
	.EQU UDR0=0xC6
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU GPIOR0=0x1E

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x08FF
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _shag=R4
	.DEF _at=R7
	.DEF _ri=R8
	.DEF _sig=R10
	.DEF _time=R12
	.DEF _b=R6

;GPIOR0 INITIALIZATION VALUE
	.EQU __GPIOR0_INIT=0xC0

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _adc_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_char0:
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x1B,0x0
_char1:
	.DB  0x0,0x0,0x0,0x0,0x0,0x3,0x1B,0x0
_char2:
	.DB  0x0,0x0,0x0,0x3,0x1B,0x1B,0x1B,0x0
_char3:
	.DB  0x0,0x3,0x1B,0x1B,0x1B,0x1B,0x1B,0x0
_char4:
	.DB  0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x0
_char5:
	.DB  0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x0
_char7:
	.DB  0x15,0x15,0xE,0x4,0x4,0x4,0x4,0x0
_char6:
	.DB  0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x1B,0x0

_0x3:
	.DB  0x1
_0x11C:
	.DB  0xE8,0x3,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0
_0x0:
	.DB  0x20,0x53,0x53,0x42,0x20,0x53,0x79,0x6E
	.DB  0x74,0x68,0x20,0x76,0x2E,0x31,0x61,0x20
	.DB  0x0,0x72,0x61,0x64,0x69,0x6F,0x72,0x75
	.DB  0x62,0x6B,0x61,0x2E,0x61,0x74,0x2E,0x75
	.DB  0x61,0x0,0x20,0x20,0x46,0x69,0x72,0x73
	.DB  0x74,0x20,0x53,0x74,0x61,0x72,0x74,0x20
	.DB  0x20,0x20,0x0,0x20,0x20,0x20,0x20,0x49
	.DB  0x46,0x20,0x53,0x65,0x74,0x75,0x70,0x20
	.DB  0x20,0x20,0x20,0x0,0x44,0x44,0x53,0x20
	.DB  0x51,0x2E,0x20,0x47,0x65,0x6E,0x20,0x53
	.DB  0x65,0x74,0x75,0x70,0x0,0x49,0x46,0x20
	.DB  0x3D,0x20,0x0,0x20,0x48,0x7A,0x0,0x45
	.DB  0x64,0x69,0x74,0x20,0x0,0x20,0x31,0x20
	.DB  0x6B,0x48,0x7A,0x0,0x31,0x30,0x20,0x6B
	.DB  0x48,0x7A,0x0,0x31,0x30,0x20,0x20,0x48
	.DB  0x7A,0x0,0x35,0x30,0x20,0x6B,0x48,0x7A
	.DB  0x0,0x31,0x20,0x20,0x6B,0x48,0x7A,0x0
	.DB  0x31,0x30,0x30,0x20,0x48,0x7A,0x0,0x31
	.DB  0x20,0x20,0x20,0x48,0x7A,0x0,0x20,0x20
	.DB  0x4B,0x6F,0x65,0x66,0x66,0x20,0x56,0x65
	.DB  0x72,0x69,0x66,0x79,0x20,0x20,0x0,0x2E
	.DB  0x0,0x30,0x0,0x54,0x20,0x0,0x20,0x32
	.DB  0x30,0x20,0x48,0x7A,0x0,0x52,0x0,0x20
	.DB  0x30,0x20,0x20,0x20,0x48,0x7A,0x0,0x2B
	.DB  0x0,0x41,0x20,0x0,0x30,0x66,0x66,0x20
	.DB  0x0,0x2D,0x31,0x30,0x20,0x0,0x2D,0x32
	.DB  0x30,0x20,0x0,0x2D,0x33,0x30,0x20,0x0
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x0,0x20,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x0,0x20,0x20
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x0
	.DB  0x5B,0x54,0x58,0x5D,0x0
_0x2000003:
	.DB  0x80,0xC0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  _sup
	.DW  _0x3*2

	.DW  0x0A
	.DW  0x04
	.DW  _0x11C*2

	.DW  0x02
	.DW  __base_y_G100
	.DW  _0x2000003*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	WDR
	IN   R26,MCUSR
	CBR  R26,8
	OUT  MCUSR,R26
	STS  WDTCSR,R31
	STS  WDTCSR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;GPIOR0 INITIALIZATION
	LDI  R30,__GPIOR0_INIT
	OUT  GPIOR0,R30

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x300

	.CSEG
;/*****************************************************
;This program was produced by the
;CodeWizardAVR V2.05.0 Professional
;Automatic Program Generator
; Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;
;Project :
;Version :
;Date    : 03.02.2014
;Author  :
;Company :
;Comments:
;
;
;Chip type               : ATmega328P
;Program type            : Application
;AVR Core Clock frequency: 8,000000 MHz
;Memory model            : Small
;External RAM size       : 0
;Data Stack size         : 512
;*****************************************************/
;#include <mega328p.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif
;#include <delay.h>
;#include <alcd.h>
;#include <stdlib.h>
;
;#define ENCA PINC.3
;#define ENCB PINC.4
;#define SET_B(x) |=(1<<x)
;#define CLR_B(x) &=~(1<<x)
;#define ATT PINB.1
;#define RIT PINB.2
;#define SN  PINB.3
;#define TXI PINC.1
;
;#define CLK PORTD.3
;#define FQ PORTD.2
;#define DATA PORTD.1
;#define RES PORTD.0
;
;unsigned long int freq;   // start freqensy
;long int f_cont;
;long int iff;             //if freqency
;
;char __eeprom f_en;       //proshivka defoltov pri pervom starte
;long int __eeprom eif;    //znachenie pch dlya eeproma
;float __eeprom ek;        //koefficient dlya sintezatora, po umolchaniy 34.359738368 (dlya taktovogo 125.000.000 MHz)
;long int __eeprom fdds;   //taktovaya chastota, po umolchaniy 125000000
;unsigned long int __eeprom sfreq;  //konstanta startovoy chastoty
;
;unsigned int shag = 1000; //shag po umolchaniu
;char at = 0;
;int ri =0;
;bit ri0 = 0;
;int sig = 0;
;int time = 0;
;
;bit if_setup=0;
;bit if_read=0;
;bit koeff_setup=0;
;bit koeff_read=0;
;
;bit tx = 0;
;bit up1 = 1;             //1 stroka
;bit up2 = 1;             //2 stroka
;char ri_h[6];
;
;char fr_k[16];           //  
;char fr_h[6];            //  
;int fr_buf_k;            //  
;int fr_buf_h;            //  
;
;static char enco;
;static char encoo;
;
;enum { State0, StateA, StateB, StateAB };
;
;char b;
;char i;
;char sup=1;

	.DSEG
;
;union un_dataword                  //
;{                                  //
;unsigned long dataword_freq;       //  
;unsigned char dataword_byte[5];    //
;}un;                               //
;
;float k;            //   = 4294967296 / F_DDS_IN
;
;
;typedef unsigned char byte;
;
;flash byte char0[8]={
;0b0000000,
;0b0000000,
;0b0000000,
;0b0000000,
;0b0000000,
;0b0000000,
;0b0011011,
;0b0000000};
;
;flash byte char1[8]={
;0b0000000,
;0b0000000,
;0b0000000,
;0b0000000,
;0b0000000,
;0b0000011,
;0b0011011,
;0b0000000};
;
;flash byte char2[8]={
;0b0000000,
;0b0000000,
;0b0000000,
;0b0000011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0000000};
;
;flash byte char3[8]={
;0b0000000,
;0b0000011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0000000};
;
;flash byte char4[8]={
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0000000};
;
;flash byte char5[8]={
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0000000};
;
;flash byte char7[8]={
;0b0010101,
;0b0010101,
;0b0001110,
;0b0000100,
;0b0000100,
;0b0000100,
;0b0000100,
;0b0000000};
;
;flash byte char6[8]={
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0011011,
;0b0000000};
;
;
;// Timer 0 overflow interrupt service routine
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 00B1 {

	.CSEG
_timer0_ovf_isr:
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
; 0000 00B2 time=time+1;
	MOVW R30,R12
	ADIW R30,1
	MOVW R12,R30
; 0000 00B3 TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 00B4 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	RETI
;
;#define ADC_VREF_TYPE 0xC0
;
;// ADC interrupt service routine
;interrupt [ADC_INT] void adc_isr(void)
; 0000 00BA {
_adc_isr:
; 0000 00BB unsigned int adc_data;
; 0000 00BC // Read the AD conversion result
; 0000 00BD adc_data=ADCW;
	ST   -Y,R17
	ST   -Y,R16
;	adc_data -> R16,R17
	__GETWRMN 16,17,0,120
; 0000 00BE sig=adc_data;
	MOVW R10,R16
; 0000 00BF up2=1;
	SBI  0x1E,7
; 0000 00C0 // Place your code here
; 0000 00C1 
; 0000 00C2 }
	LD   R16,Y+
	LD   R17,Y+
	RETI
;
;void define_char(byte flash *pc,byte char_code)
; 0000 00C5  {
_define_char:
; 0000 00C6  byte i,a;
; 0000 00C7  a=(char_code<<3)|0x40;
	ST   -Y,R17
	ST   -Y,R16
;	*pc -> Y+3
;	char_code -> Y+2
;	i -> R17
;	a -> R16
	LDD  R30,Y+2
	LSL  R30
	LSL  R30
	LSL  R30
	ORI  R30,0x40
	MOV  R16,R30
; 0000 00C8  for (i=0; i<8; i++) lcd_write_byte(a++,*pc++);
	LDI  R17,LOW(0)
_0x7:
	CPI  R17,8
	BRSH _0x8
	ST   -Y,R16
	INC  R16
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	SBIW R30,1
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
	SUBI R17,-1
	RJMP _0x7
_0x8:
; 0000 00C9 }
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
;
;void Encoder_Init(void)
; 0000 00CC {
_Encoder_Init:
; 0000 00CD   enco = State0;       //????????????? ??????????? ?????????
	LDI  R30,LOW(0)
	STS  _enco_G000,R30
; 0000 00CE   encoo = State0;   //????????????? ????-??????????? ?????????
	STS  _encoo_G000,R30
; 0000 00CF }
	RET
;
;void Encoder_Exe(void)
; 0000 00D2 {
_Encoder_Exe:
; 0000 00D3   char EncCur = 0;
; 0000 00D4   if(!ENCA) EncCur  = StateA; //????? ???? 1 ????????
	ST   -Y,R17
;	EncCur -> R17
	LDI  R17,0
	SBIS 0x6,3
	LDI  R17,LOW(1)
; 0000 00D5   if(!ENCB) EncCur |= StateB; //????? ???? 2 ????????
	SBIS 0x6,4
	ORI  R17,LOW(2)
; 0000 00D6   if(EncCur != enco)             //???? ????????? ??????????,
	LDS  R30,_enco_G000
	CP   R30,R17
	BREQ _0xB
; 0000 00D7   {
; 0000 00D8     if(enco == StateAB &&        //???? ?????????? ????????? StateAB
; 0000 00D9        EncCur != encoo )      //? ??????? ? ????-?????????? ?? ?????,
	LDS  R26,_enco_G000
	CPI  R26,LOW(0x3)
	BRNE _0xD
	LDS  R30,_encoo_G000
	CP   R30,R17
	BRNE _0xE
_0xD:
	RJMP _0xC
_0xE:
; 0000 00DA     {
; 0000 00DB       if(EncCur == StateB) {          //???? ??????? ????????? StateB,
	CPI  R17,2
	BRNE _0xF
; 0000 00DC         if (ri0==0) {
	SBIC 0x1E,0
	RJMP _0x10
; 0000 00DD         freq = freq + shag;            //??? ?????
	CALL SUBOPT_0x0
	CALL __ADDD12
	CALL SUBOPT_0x1
; 0000 00DE         up1 = 1;
	RJMP _0x111
; 0000 00DF                    } else {
_0x10:
; 0000 00E0                                 if (ri<999) {
	LDI  R30,LOW(999)
	LDI  R31,HIGH(999)
	CP   R8,R30
	CPC  R9,R31
	BRGE _0x14
; 0000 00E1                                 ri = ri + 10;
	MOVW R30,R8
	ADIW R30,10
	MOVW R8,R30
; 0000 00E2                                 up1 = 1;     };
_0x111:
	SBI  0x1E,6
_0x14:
; 0000 00E3         };
; 0000 00E4                    }
; 0000 00E5       else {                         //?????
	RJMP _0x17
_0xF:
; 0000 00E6         if (ri0==0) {
	SBIC 0x1E,0
	RJMP _0x18
; 0000 00E7         freq = freq - shag;            //??? ?????
	CALL SUBOPT_0x0
	CALL __SUBD21
	STS  _freq,R26
	STS  _freq+1,R27
	STS  _freq+2,R24
	STS  _freq+3,R25
; 0000 00E8         up1 = 1;
	RJMP _0x112
; 0000 00E9                    } else {
_0x18:
; 0000 00EA                                 if (ri>-999) {
	LDI  R30,LOW(64537)
	LDI  R31,HIGH(64537)
	CP   R30,R8
	CPC  R31,R9
	BRGE _0x1C
; 0000 00EB                                 ri = ri - 10;
	MOVW R30,R8
	SBIW R30,10
	MOVW R8,R30
; 0000 00EC                                 up1 = 1;      };
_0x112:
	SBI  0x1E,6
_0x1C:
; 0000 00ED         };
; 0000 00EE 
; 0000 00EF                    };
_0x17:
; 0000 00F0            }
; 0000 00F1     encoo = enco;          //?????????? ????-??????????? ?????????
_0xC:
	LDS  R30,_enco_G000
	STS  _encoo_G000,R30
; 0000 00F2     enco = EncCur;               //?????????? ??????????? ?????????
	STS  _enco_G000,R17
; 0000 00F3   }
; 0000 00F4 }
_0xB:
	LD   R17,Y+
	RET
;
;void main(void)
; 0000 00F7 {
_main:
; 0000 00F8 // Declare your local variables here
; 0000 00F9 
; 0000 00FA // Crystal Oscillator division factor: 1
; 0000 00FB #pragma optsize-
; 0000 00FC CLKPR=0x80;
	LDI  R30,LOW(128)
	STS  97,R30
; 0000 00FD CLKPR=0x00;
	LDI  R30,LOW(0)
	STS  97,R30
; 0000 00FE #ifdef _OPTIMIZE_SIZE_
; 0000 00FF #pragma optsize+
; 0000 0100 #endif
; 0000 0101 
; 0000 0102 // Input/Output Ports initialization
; 0000 0103 // Port B initialization
; 0000 0104 // Func7=In Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 0105 // State7=T State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T
; 0000 0106 PORTB=0x00;
	OUT  0x5,R30
; 0000 0107 DDRB=0x30;
	LDI  R30,LOW(48)
	OUT  0x4,R30
; 0000 0108 
; 0000 0109 // Port C initialization
; 0000 010A // Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=In Func0=In
; 0000 010B // State6=T State5=T State4=T State3=T State2=0 State1=T State0=T
; 0000 010C PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x8,R30
; 0000 010D DDRC=0x04;
	LDI  R30,LOW(4)
	OUT  0x7,R30
; 0000 010E 
; 0000 010F // Port D initialization
; 0000 0110 // Func7=In Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=Out
; 0000 0111 // State7=T State6=T State5=T State4=T State3=0 State2=0 State1=0 State0=0
; 0000 0112 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 0113 DDRD=0x0F;
	LDI  R30,LOW(15)
	OUT  0xA,R30
; 0000 0114 
; 0000 0115 // Timer/Counter 0 initialization
; 0000 0116 // Clock source: System Clock
; 0000 0117 // Clock value: 7,813 kHz
; 0000 0118 // Mode: Normal top=0xFF
; 0000 0119 // OC0A output: Disconnected
; 0000 011A // OC0B output: Disconnected
; 0000 011B TCCR0A=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
; 0000 011C TCCR0B=0x05;
	LDI  R30,LOW(5)
	OUT  0x25,R30
; 0000 011D TCNT0=0x00;
	LDI  R30,LOW(0)
	OUT  0x26,R30
; 0000 011E OCR0A=0x00;
	OUT  0x27,R30
; 0000 011F OCR0B=0x00;
	OUT  0x28,R30
; 0000 0120 
; 0000 0121 // Timer/Counter 1 initialization
; 0000 0122 // Clock source: System Clock
; 0000 0123 // Clock value: Timer1 Stopped
; 0000 0124 // Mode: Normal top=0xFFFF
; 0000 0125 // OC1A output: Discon.
; 0000 0126 // OC1B output: Discon.
; 0000 0127 // Noise Canceler: Off
; 0000 0128 // Input Capture on Falling Edge
; 0000 0129 // Timer1 Overflow Interrupt: Off
; 0000 012A // Input Capture Interrupt: Off
; 0000 012B // Compare A Match Interrupt: Off
; 0000 012C // Compare B Match Interrupt: Off
; 0000 012D TCCR1A=0x00;
	STS  128,R30
; 0000 012E TCCR1B=0x00;
	STS  129,R30
; 0000 012F TCNT1H=0x00;
	STS  133,R30
; 0000 0130 TCNT1L=0x00;
	STS  132,R30
; 0000 0131 ICR1H=0x00;
	STS  135,R30
; 0000 0132 ICR1L=0x00;
	STS  134,R30
; 0000 0133 OCR1AH=0x00;
	STS  137,R30
; 0000 0134 OCR1AL=0x00;
	STS  136,R30
; 0000 0135 OCR1BH=0x00;
	STS  139,R30
; 0000 0136 OCR1BL=0x00;
	STS  138,R30
; 0000 0137 
; 0000 0138 // Timer/Counter 2 initialization
; 0000 0139 // Clock source: System Clock
; 0000 013A // Clock value: Timer2 Stopped
; 0000 013B // Mode: Normal top=0xFF
; 0000 013C // OC2A output: Disconnected
; 0000 013D // OC2B output: Disconnected
; 0000 013E ASSR=0x00;
	STS  182,R30
; 0000 013F TCCR2A=0x00;
	STS  176,R30
; 0000 0140 TCCR2B=0x00;
	STS  177,R30
; 0000 0141 TCNT2=0x00;
	STS  178,R30
; 0000 0142 OCR2A=0x00;
	STS  179,R30
; 0000 0143 OCR2B=0x00;
	STS  180,R30
; 0000 0144 
; 0000 0145 // External Interrupt(s) initialization
; 0000 0146 // INT0: Off
; 0000 0147 // INT1: Off
; 0000 0148 // Interrupt on any change on pins PCINT0-7: Off
; 0000 0149 // Interrupt on any change on pins PCINT8-14: Off
; 0000 014A // Interrupt on any change on pins PCINT16-23: Off
; 0000 014B EICRA=0x00;
	STS  105,R30
; 0000 014C EIMSK=0x00;
	OUT  0x1D,R30
; 0000 014D PCICR=0x00;
	STS  104,R30
; 0000 014E 
; 0000 014F // Timer/Counter 0 Interrupt(s) initialization
; 0000 0150 TIMSK0=0x01;
	LDI  R30,LOW(1)
	STS  110,R30
; 0000 0151 
; 0000 0152 // Timer/Counter 1 Interrupt(s) initialization
; 0000 0153 TIMSK1=0x00;
	LDI  R30,LOW(0)
	STS  111,R30
; 0000 0154 
; 0000 0155 // Timer/Counter 2 Interrupt(s) initialization
; 0000 0156 TIMSK2=0x00;
	STS  112,R30
; 0000 0157 
; 0000 0158 // USART initialization
; 0000 0159 // USART disabled
; 0000 015A UCSR0B=0x00;
	STS  193,R30
; 0000 015B 
; 0000 015C // Analog Comparator initialization
; 0000 015D // Analog Comparator: Off
; 0000 015E // Analog Comparator Input Capture by Timer/Counter 1: Off
; 0000 015F ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x30,R30
; 0000 0160 ADCSRB=0x00;
	LDI  R30,LOW(0)
	STS  123,R30
; 0000 0161 DIDR1=0x00;
	STS  127,R30
; 0000 0162 
; 0000 0163 // ADC initialization
; 0000 0164 // ADC Clock frequency: 1000,000 kHz
; 0000 0165 // ADC Voltage Reference: Int., cap. on AREF
; 0000 0166 // ADC Auto Trigger Source: ADC Stopped
; 0000 0167 // Digital input buffers on ADC0: On, ADC1: On, ADC2: On, ADC3: On
; 0000 0168 // ADC4: On, ADC5: On
; 0000 0169 DIDR0=0x00;
	STS  126,R30
; 0000 016A ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(192)
	STS  124,R30
; 0000 016B ADCSRA=0x8B;
	LDI  R30,LOW(139)
	STS  122,R30
; 0000 016C 
; 0000 016D // SPI initialization
; 0000 016E // SPI disabled
; 0000 016F SPCR=0x00;
	LDI  R30,LOW(0)
	OUT  0x2C,R30
; 0000 0170 
; 0000 0171 // TWI initialization
; 0000 0172 // TWI disabled
; 0000 0173 TWCR=0x00;
	STS  188,R30
; 0000 0174 
; 0000 0175 // Alphanumeric LCD initialization
; 0000 0176 // Connections specified in the
; 0000 0177 // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 0178 // RS - PORTB Bit 0
; 0000 0179 // RD - PORTD Bit 7
; 0000 017A // EN - PORTD Bit 6
; 0000 017B // D4 - PORTD Bit 5
; 0000 017C // D5 - PORTB Bit 7
; 0000 017D // D6 - PORTB Bit 6
; 0000 017E // D7 - PORTD Bit 4
; 0000 017F // Characters/line: 16
; 0000 0180 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
; 0000 0181 define_char(char0,0);
	LDI  R30,LOW(_char0*2)
	LDI  R31,HIGH(_char0*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _define_char
; 0000 0182 define_char(char1,1);
	LDI  R30,LOW(_char1*2)
	LDI  R31,HIGH(_char1*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _define_char
; 0000 0183 define_char(char2,2);
	LDI  R30,LOW(_char2*2)
	LDI  R31,HIGH(_char2*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _define_char
; 0000 0184 define_char(char3,3);
	LDI  R30,LOW(_char3*2)
	LDI  R31,HIGH(_char3*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _define_char
; 0000 0185 define_char(char4,4);
	LDI  R30,LOW(_char4*2)
	LDI  R31,HIGH(_char4*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _define_char
; 0000 0186 define_char(char5,5);
	LDI  R30,LOW(_char5*2)
	LDI  R31,HIGH(_char5*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _define_char
; 0000 0187 define_char(char6,6);
	LDI  R30,LOW(_char6*2)
	LDI  R31,HIGH(_char6*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _define_char
; 0000 0188 define_char(char7,7);
	LDI  R30,LOW(_char7*2)
	LDI  R31,HIGH(_char7*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(7)
	ST   -Y,R30
	RCALL _define_char
; 0000 0189 
; 0000 018A {
; 0000 018B if (f_en==5) {
	LDI  R26,LOW(_f_en)
	LDI  R27,HIGH(_f_en)
	CALL __EEPROMRDB
	CPI  R30,LOW(0x5)
	BRNE _0x1F
; 0000 018C                 lcd_gotoxy(0,0);
	CALL SUBOPT_0x2
; 0000 018D                 lcd_putsf(" SSB Synth v.1a ");
; 0000 018E                 lcd_gotoxy(0,1);
; 0000 018F                 lcd_putsf("radiorubka.at.ua");
	__POINTW1FN _0x0,17
	CALL SUBOPT_0x3
; 0000 0190               } else {
	RJMP _0x20
_0x1F:
; 0000 0191                 lcd_gotoxy(0,0);
	CALL SUBOPT_0x2
; 0000 0192                 lcd_putsf(" SSB Synth v.1a ");
; 0000 0193                 lcd_gotoxy(0,1);
; 0000 0194                 lcd_putsf("  First Start   ");
	__POINTW1FN _0x0,34
	CALL SUBOPT_0x3
; 0000 0195                 sfreq=6500000;
	LDI  R26,LOW(_sfreq)
	LDI  R27,HIGH(_sfreq)
	__GETD1N 0x632EA0
	CALL __EEPROMWRD
; 0000 0196                 eif=500000;
	LDI  R26,LOW(_eif)
	LDI  R27,HIGH(_eif)
	__GETD1N 0x7A120
	CALL __EEPROMWRD
; 0000 0197                 fdds=125000000;
	LDI  R26,LOW(_fdds)
	LDI  R27,HIGH(_fdds)
	__GETD1N 0x7735940
	CALL __EEPROMWRD
; 0000 0198                 ek=4294967296/fdds;
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
; 0000 0199                 f_en=5;
	LDI  R26,LOW(_f_en)
	LDI  R27,HIGH(_f_en)
	LDI  R30,LOW(5)
	CALL __EEPROMWRB
; 0000 019A               };
_0x20:
; 0000 019B 
; 0000 019C if (!RIT) {
	SBIC 0x3,2
	RJMP _0x21
; 0000 019D         if_setup=1;
	SBI  0x1E,1
; 0000 019E         lcd_gotoxy(0,0);
	CALL SUBOPT_0x2
; 0000 019F         lcd_putsf(" SSB Synth v.1a ");
; 0000 01A0         lcd_gotoxy(0,1);
; 0000 01A1         lcd_putsf("    IF Setup    ");
	__POINTW1FN _0x0,51
	CALL SUBOPT_0x3
; 0000 01A2           } else {
	RJMP _0x24
_0x21:
; 0000 01A3         if_setup=0;
	CBI  0x1E,1
; 0000 01A4           };
_0x24:
; 0000 01A5 
; 0000 01A6 if (!ATT) {
	SBIC 0x3,1
	RJMP _0x27
; 0000 01A7         koeff_setup=1;
	SBI  0x1E,3
; 0000 01A8         lcd_gotoxy(0,0);
	CALL SUBOPT_0x2
; 0000 01A9         lcd_putsf(" SSB Synth v.1a ");
; 0000 01AA         lcd_gotoxy(0,1);
; 0000 01AB         lcd_putsf("DDS Q. Gen Setup");
	__POINTW1FN _0x0,68
	CALL SUBOPT_0x3
; 0000 01AC           } else {
	RJMP _0x2A
_0x27:
; 0000 01AD         koeff_setup=0;
	CBI  0x1E,3
; 0000 01AE           };
_0x2A:
; 0000 01AF }
; 0000 01B0 
; 0000 01B1 Encoder_Init();
	RCALL _Encoder_Init
; 0000 01B2 ADMUX CLR_B(0);   //
	LDS  R30,124
	ANDI R30,0xFE
	CALL SUBOPT_0x6
; 0000 01B3 ADMUX CLR_B(1);   //    ( adc0)
	ANDI R30,0xFD
	CALL SUBOPT_0x6
; 0000 01B4 ADMUX CLR_B(2);   //
	ANDI R30,0xFB
	CALL SUBOPT_0x6
; 0000 01B5 ADMUX CLR_B(3);   //
	ANDI R30,0XF7
	STS  124,R30
; 0000 01B6 delay_ms(2000);
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	CALL SUBOPT_0x7
; 0000 01B7 RES=1;
	SBI  0xB,0
; 0000 01B8 RES=0;
	CBI  0xB,0
; 0000 01B9 lcd_clear();
	CALL _lcd_clear
; 0000 01BA 
; 0000 01BB while (if_setup==1) {
_0x31:
	SBIS 0x1E,1
	RJMP _0x33
; 0000 01BC 
; 0000 01BD if (if_read==0) {
	SBIC 0x1E,2
	RJMP _0x34
; 0000 01BE                 freq=eif;
	LDI  R26,LOW(_eif)
	LDI  R27,HIGH(_eif)
	CALL __EEPROMRDD
	CALL SUBOPT_0x1
; 0000 01BF                 if_read=1;
	SBI  0x1E,2
; 0000 01C0                 };
_0x34:
; 0000 01C1 
; 0000 01C2 if (up1 == 1) {
	SBIS 0x1E,6
	RJMP _0x37
; 0000 01C3                         lcd_clear();
	CALL SUBOPT_0x8
; 0000 01C4                         lcd_gotoxy(0,0);
; 0000 01C5 
; 0000 01C6                         lcd_putsf ("IF = ");
	__POINTW1FN _0x0,85
	CALL SUBOPT_0x3
; 0000 01C7 
; 0000 01C8                         ltoa(freq, fr_k);     //
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
; 0000 01C9 
; 0000 01CA                         lcd_puts (fr_k);          // 
; 0000 01CB                         lcd_putsf (" Hz");          // 
; 0000 01CC 
; 0000 01CD                         up1 = 0;
	CBI  0x1E,6
; 0000 01CE                         up2 = 1;
	SBI  0x1E,7
; 0000 01CF                 }
; 0000 01D0 
; 0000 01D1  if (up2 == 1) {
_0x37:
	SBIS 0x1E,7
	RJMP _0x3C
; 0000 01D2                         lcd_gotoxy(0,1);
	CALL SUBOPT_0xB
; 0000 01D3                         lcd_putsf("Edit ");
; 0000 01D4 
; 0000 01D5                         if (shag == 1000) {
	CALL SUBOPT_0xC
	BRNE _0x3D
; 0000 01D6                         lcd_putsf (" 1 kHz");
	__POINTW1FN _0x0,101
	CALL SUBOPT_0x3
; 0000 01D7                                           };
_0x3D:
; 0000 01D8                         if (shag == 10000) {
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x3E
; 0000 01D9                         lcd_putsf ("10 kHz");
	__POINTW1FN _0x0,108
	CALL SUBOPT_0x3
; 0000 01DA                                           };
_0x3E:
; 0000 01DB                         if (shag == 10) {
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x3F
; 0000 01DC                         lcd_putsf ("10  Hz");
	__POINTW1FN _0x0,115
	CALL SUBOPT_0x3
; 0000 01DD                                           };
_0x3F:
; 0000 01DE                         if (shag == 50000) {
	LDI  R30,LOW(50000)
	LDI  R31,HIGH(50000)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x40
; 0000 01DF                         lcd_putsf ("50 kHz");
	__POINTW1FN _0x0,122
	CALL SUBOPT_0x3
; 0000 01E0                                           };
_0x40:
; 0000 01E1                         up2 = 0;
	CBI  0x1E,7
; 0000 01E2                         }
; 0000 01E3 
; 0000 01E4                         Encoder_Exe();
_0x3C:
	RCALL _Encoder_Exe
; 0000 01E5 
; 0000 01E6        if (!SN) {
	SBIC 0x3,3
	RJMP _0x43
; 0000 01E7                         switch (shag) {
	MOVW R30,R4
; 0000 01E8                         case 10: shag=1000; up2 = 1; delay_ms(300); break;
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x47
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP _0x113
; 0000 01E9                         case 1000: shag=10000; up2 = 1; delay_ms(300); break;
_0x47:
	CPI  R30,LOW(0x3E8)
	LDI  R26,HIGH(0x3E8)
	CPC  R31,R26
	BRNE _0x4A
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	RJMP _0x113
; 0000 01EA                         case 10000: shag=50000; up2 = 1; delay_ms(300); break;
_0x4A:
	CPI  R30,LOW(0x2710)
	LDI  R26,HIGH(0x2710)
	CPC  R31,R26
	BRNE _0x4D
	LDI  R30,LOW(50000)
	LDI  R31,HIGH(50000)
	RJMP _0x113
; 0000 01EB                         case 50000: shag=10; up2 = 1; delay_ms(300); break;
_0x4D:
	CPI  R30,LOW(0xC350)
	LDI  R26,HIGH(0xC350)
	CPC  R31,R26
	BRNE _0x46
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
_0x113:
	MOVW R4,R30
	SBI  0x1E,7
	CALL SUBOPT_0xD
; 0000 01EC                                     };
_0x46:
; 0000 01ED                                     };
_0x43:
; 0000 01EE        if (!ATT) {
	SBIC 0x3,1
	RJMP _0x53
; 0000 01EF                         eif=freq;
	CALL SUBOPT_0x9
	LDI  R26,LOW(_eif)
	LDI  R27,HIGH(_eif)
	CALL __EEPROMWRD
; 0000 01F0                         up1=1;
	CALL SUBOPT_0xE
; 0000 01F1                         up2=1;
; 0000 01F2                         shag=1000;
; 0000 01F3                         lcd_clear();
; 0000 01F4                         delay_ms(1000);
; 0000 01F5                         if_setup=0;
	CBI  0x1E,1
; 0000 01F6                  };
_0x53:
; 0000 01F7                         };
	RJMP _0x31
_0x33:
; 0000 01F8 
; 0000 01F9 while (koeff_setup==1) {
_0x5A:
	SBIS 0x1E,3
	RJMP _0x5C
; 0000 01FA 
; 0000 01FB if (koeff_read==0) {
	SBIC 0x1E,4
	RJMP _0x5D
; 0000 01FC                 freq=fdds;
	CALL SUBOPT_0x4
	CALL SUBOPT_0x1
; 0000 01FD                 koeff_read=1;
	SBI  0x1E,4
; 0000 01FE                 };
_0x5D:
; 0000 01FF 
; 0000 0200 if (up1 == 1) {
	SBIS 0x1E,6
	RJMP _0x60
; 0000 0201                         lcd_gotoxy(0,0);
	CALL SUBOPT_0xF
; 0000 0202 
; 0000 0203                         lcd_putsf ("F = ");
	__POINTW1FN _0x0,86
	CALL SUBOPT_0x3
; 0000 0204 
; 0000 0205                         ltoa(freq, fr_k);     //
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
; 0000 0206 
; 0000 0207                         lcd_puts (fr_k);          // 
; 0000 0208                         lcd_putsf (" Hz");          // 
; 0000 0209 
; 0000 020A                         up1 = 0;
	CBI  0x1E,6
; 0000 020B 
; 0000 020C                 }
; 0000 020D 
; 0000 020E  if (up2 == 1) {
_0x60:
	SBIS 0x1E,7
	RJMP _0x63
; 0000 020F                         lcd_gotoxy(0,1);
	CALL SUBOPT_0xB
; 0000 0210                         lcd_putsf("Edit ");
; 0000 0211 
; 0000 0212                         if (shag == 1000) {
	CALL SUBOPT_0xC
	BRNE _0x64
; 0000 0213                         lcd_putsf ("1  kHz");
	__POINTW1FN _0x0,129
	CALL SUBOPT_0x3
; 0000 0214                                           };
_0x64:
; 0000 0215                         if (shag == 100) {
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x65
; 0000 0216                         lcd_putsf ("100 Hz");
	__POINTW1FN _0x0,136
	CALL SUBOPT_0x3
; 0000 0217                                           };
_0x65:
; 0000 0218                         if (shag == 10) {
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x66
; 0000 0219                         lcd_putsf ("10  Hz");
	__POINTW1FN _0x0,115
	CALL SUBOPT_0x3
; 0000 021A                                           };
_0x66:
; 0000 021B                         if (shag == 1) {
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x67
; 0000 021C                         lcd_putsf ("1   Hz");
	__POINTW1FN _0x0,143
	CALL SUBOPT_0x3
; 0000 021D                                           };
_0x67:
; 0000 021E                         up2 = 0;
	CBI  0x1E,7
; 0000 021F                         }
; 0000 0220 
; 0000 0221                         Encoder_Exe();
_0x63:
	RCALL _Encoder_Exe
; 0000 0222 
; 0000 0223        if (!SN) {
	SBIC 0x3,3
	RJMP _0x6A
; 0000 0224                         switch (shag) {
	MOVW R30,R4
; 0000 0225                         case 100: shag=1000; up2 = 1; delay_ms(300); break;
	CPI  R30,LOW(0x64)
	LDI  R26,HIGH(0x64)
	CPC  R31,R26
	BRNE _0x6E
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP _0x114
; 0000 0226                         case 1000: shag=1; up2 = 1; delay_ms(300); break;
_0x6E:
	CPI  R30,LOW(0x3E8)
	LDI  R26,HIGH(0x3E8)
	CPC  R31,R26
	BRNE _0x71
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RJMP _0x114
; 0000 0227                         case 1: shag=10; up2 = 1; delay_ms(300); break;
_0x71:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x74
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RJMP _0x114
; 0000 0228                         case 10: shag=100; up2 = 1; delay_ms(300); break;
_0x74:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0x6D
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
_0x114:
	MOVW R4,R30
	SBI  0x1E,7
	CALL SUBOPT_0xD
; 0000 0229                                     };
_0x6D:
; 0000 022A                                     };
_0x6A:
; 0000 022B        if (!RIT) {
	SBIC 0x3,2
	RJMP _0x7A
; 0000 022C                         fdds=freq;
	CALL SUBOPT_0x9
	LDI  R26,LOW(_fdds)
	LDI  R27,HIGH(_fdds)
	CALL __EEPROMWRD
; 0000 022D                         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0x7
; 0000 022E                         ek=4294967296/fdds;
	CALL SUBOPT_0x4
	CALL SUBOPT_0x5
; 0000 022F                         delay_ms(100);
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL SUBOPT_0x7
; 0000 0230                         lcd_clear();
	CALL SUBOPT_0x8
; 0000 0231                         lcd_gotoxy(0,0);
; 0000 0232                         lcd_putsf ("  Koeff Verify  ");
	__POINTW1FN _0x0,150
	CALL SUBOPT_0x3
; 0000 0233                         freq=4294967296/ek;
	LDI  R26,LOW(_ek)
	LDI  R27,HIGH(_ek)
	CALL __EEPROMRDD
	__GETD2N 0x4F800000
	CALL __DIVF21
	LDI  R26,LOW(_freq)
	LDI  R27,HIGH(_freq)
	CALL __CFD1U
	CALL __PUTDP1
; 0000 0234                         ltoa(freq, fr_k);     //
	CALL SUBOPT_0x9
	CALL SUBOPT_0x10
; 0000 0235                         lcd_gotoxy(0,1);
	CALL SUBOPT_0x11
; 0000 0236                         lcd_putsf("   ");
	__POINTW1FN _0x0,47
	CALL SUBOPT_0x3
; 0000 0237                         lcd_puts (fr_k);          // 
	CALL SUBOPT_0x12
; 0000 0238                         delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	CALL SUBOPT_0x7
; 0000 0239                         up1=1;
	CALL SUBOPT_0xE
; 0000 023A                         up2=1;
; 0000 023B                         shag=1000;
; 0000 023C                         lcd_clear();
; 0000 023D                         delay_ms(1000);
; 0000 023E                         koeff_setup=0;
	CBI  0x1E,3
; 0000 023F                  };
_0x7A:
; 0000 0240                         };
	RJMP _0x5A
_0x5C:
; 0000 0241 
; 0000 0242 k=ek;
	LDI  R26,LOW(_ek)
	LDI  R27,HIGH(_ek)
	CALL __EEPROMRDD
	STS  _k,R30
	STS  _k+1,R31
	STS  _k+2,R22
	STS  _k+3,R23
; 0000 0243 iff=eif;
	LDI  R26,LOW(_eif)
	LDI  R27,HIGH(_eif)
	CALL __EEPROMRDD
	STS  _iff,R30
	STS  _iff+1,R31
	STS  _iff+2,R22
	STS  _iff+3,R23
; 0000 0244 freq=sfreq;
	LDI  R26,LOW(_sfreq)
	LDI  R27,HIGH(_sfreq)
	CALL __EEPROMRDD
	CALL SUBOPT_0x1
; 0000 0245 
; 0000 0246 
; 0000 0247 
; 0000 0248 // Global enable interrupts
; 0000 0249 #asm("sei")
	sei
; 0000 024A 
; 0000 024B while (1)
_0x81:
; 0000 024C       {
; 0000 024D             //1 stroka
; 0000 024E             if (up1 == 1) {
	SBIS 0x1E,6
	RJMP _0x84
; 0000 024F                         lcd_gotoxy(0,0);
	CALL SUBOPT_0xF
; 0000 0250 
; 0000 0251                         fr_buf_k = (freq/1000);     // 
	CALL SUBOPT_0x13
	CALL __DIVD21U
	STS  _fr_buf_k,R30
	STS  _fr_buf_k+1,R31
; 0000 0252                         fr_buf_h = (freq%1000)/10;     // 
	CALL SUBOPT_0x13
	CALL __MODD21U
	MOVW R26,R30
	MOVW R24,R22
	CALL SUBOPT_0x14
	STS  _fr_buf_h,R30
	STS  _fr_buf_h+1,R31
; 0000 0253 
; 0000 0254 
; 0000 0255                         ltoa(fr_buf_k, fr_k);     //
	LDS  R30,_fr_buf_k
	LDS  R31,_fr_buf_k+1
	CALL __CWD1
	CALL SUBOPT_0x10
; 0000 0256                         ltoa(fr_buf_h, fr_h);     //  
	LDS  R30,_fr_buf_h
	LDS  R31,_fr_buf_h+1
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R30,LOW(_fr_h)
	LDI  R31,HIGH(_fr_h)
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 0257 
; 0000 0258                         lcd_puts (fr_k);          // 
	CALL SUBOPT_0x12
; 0000 0259                         lcd_putsf (".");          // 
	__POINTW1FN _0x0,167
	CALL SUBOPT_0x3
; 0000 025A 
; 0000 025B                         if (fr_buf_h<10) {
	LDS  R26,_fr_buf_h
	LDS  R27,_fr_buf_h+1
	SBIW R26,10
	BRGE _0x85
; 0000 025C                         lcd_putsf ("0");
	__POINTW1FN _0x0,169
	CALL SUBOPT_0x3
; 0000 025D                         lcd_puts (fr_h);  } else {
_0x85:
; 0000 025E                         lcd_puts (fr_h);  };         // 
_0x115:
	LDI  R30,LOW(_fr_h)
	LDI  R31,HIGH(_fr_h)
	CALL SUBOPT_0x15
; 0000 025F                         lcd_putsf (" ");                 // kHz
	__POINTW1FN _0x0,15
	CALL SUBOPT_0x3
; 0000 0260 
; 0000 0261                         if (ri0==0)       {
	SBIC 0x1E,0
	RJMP _0x87
; 0000 0262                         lcd_putsf ("T ");                 // kHz
	__POINTW1FN _0x0,171
	CALL SUBOPT_0x3
; 0000 0263 
; 0000 0264                         if (shag == 1000) {
	CALL SUBOPT_0xC
	BRNE _0x88
; 0000 0265                         lcd_putsf (" 1 kHz");
	__POINTW1FN _0x0,101
	CALL SUBOPT_0x3
; 0000 0266                                           };
_0x88:
; 0000 0267                         if (shag == 10000) {
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x89
; 0000 0268                         lcd_putsf ("10 kHz");
	__POINTW1FN _0x0,108
	CALL SUBOPT_0x3
; 0000 0269                                           };
_0x89:
; 0000 026A                         if (shag == 20) {
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CP   R30,R4
	CPC  R31,R5
	BRNE _0x8A
; 0000 026B                         lcd_putsf (" 20 Hz");
	__POINTW1FN _0x0,174
	CALL SUBOPT_0x3
; 0000 026C                                           };
_0x8A:
; 0000 026D                         lcd_putsf ("");
	__POINTW1FN _0x0,16
	RJMP _0x116
; 0000 026E                                           } else {
_0x87:
; 0000 026F 
; 0000 0270                         lcd_putsf ("R");
	__POINTW1FN _0x0,181
	CALL SUBOPT_0x3
; 0000 0271 
; 0000 0272                         ltoa(ri, ri_h);     //  
	MOVW R30,R8
	CALL __CWD1
	CALL __PUTPARD1
	LDI  R30,LOW(_ri_h)
	LDI  R31,HIGH(_ri_h)
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
; 0000 0273 
; 0000 0274                         if (ri==0) {
	MOV  R0,R8
	OR   R0,R9
	BRNE _0x8C
; 0000 0275                         lcd_putsf (" 0   Hz");
	__POINTW1FN _0x0,183
	CALL SUBOPT_0x3
; 0000 0276                                 };
_0x8C:
; 0000 0277                         if (ri>0 & ri<=99) {
	MOVW R26,R8
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __GTW12
	MOV  R0,R30
	LDI  R30,LOW(99)
	LDI  R31,HIGH(99)
	CALL __LEW12
	AND  R30,R0
	BREQ _0x8D
; 0000 0278                         lcd_putsf ("+");
	__POINTW1FN _0x0,191
	CALL SUBOPT_0x3
; 0000 0279                         lcd_puts (ri_h);          // 
	CALL SUBOPT_0x16
; 0000 027A                         lcd_putsf ("  Hz");
	__POINTW1FN _0x0,117
	CALL SUBOPT_0x3
; 0000 027B                                 };
_0x8D:
; 0000 027C                         if (ri>99 & ri<=999) {
	MOVW R26,R8
	LDI  R30,LOW(99)
	LDI  R31,HIGH(99)
	CALL __GTW12
	MOV  R0,R30
	LDI  R30,LOW(999)
	LDI  R31,HIGH(999)
	CALL __LEW12
	AND  R30,R0
	BREQ _0x8E
; 0000 027D                         lcd_putsf ("+");
	__POINTW1FN _0x0,191
	CALL SUBOPT_0x3
; 0000 027E                         lcd_puts (ri_h);          // 
	CALL SUBOPT_0x16
; 0000 027F                         lcd_putsf (" Hz");
	__POINTW1FN _0x0,91
	CALL SUBOPT_0x3
; 0000 0280                                 };
_0x8E:
; 0000 0281 
; 0000 0282 
; 0000 0283                       if (ri<0 & ri>=-99) {
	MOVW R26,R8
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __LTW12
	MOV  R0,R30
	LDI  R30,LOW(65437)
	LDI  R31,HIGH(65437)
	CALL __GEW12
	AND  R30,R0
	BREQ _0x8F
; 0000 0284                       lcd_puts (ri_h);          // 
	CALL SUBOPT_0x16
; 0000 0285                       lcd_putsf ("  Hz");
	__POINTW1FN _0x0,117
	CALL SUBOPT_0x3
; 0000 0286                       };
_0x8F:
; 0000 0287                       if (ri<-99 & ri>=-999) {
	MOVW R26,R8
	LDI  R30,LOW(65437)
	LDI  R31,HIGH(65437)
	CALL __LTW12
	MOV  R0,R30
	LDI  R30,LOW(64537)
	LDI  R31,HIGH(64537)
	CALL __GEW12
	AND  R30,R0
	BREQ _0x90
; 0000 0288                       lcd_puts (ri_h);          // 
	CALL SUBOPT_0x16
; 0000 0289                       lcd_putsf (" Hz");
	__POINTW1FN _0x0,91
_0x116:
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
; 0000 028A                       };
_0x90:
; 0000 028B 
; 0000 028C 
; 0000 028D                                          };
; 0000 028E 
; 0000 028F 
; 0000 0290 
; 0000 0291 
; 0000 0292 
; 0000 0293 
; 0000 0294                         up1 = 0;                      //   
	CBI  0x1E,6
; 0000 0295                         sup = 1;
	LDI  R30,LOW(1)
	STS  _sup,R30
; 0000 0296 
; 0000 0297                         };
_0x84:
; 0000 0298 
; 0000 0299             if (up2 == 1) {
	SBIS 0x1E,7
	RJMP _0x93
; 0000 029A                         if (tx == 0) {
	SBIC 0x1E,5
	RJMP _0x94
; 0000 029B                         lcd_gotoxy(0,1);
	CALL SUBOPT_0x11
; 0000 029C                         lcd_putsf("A ");
	__POINTW1FN _0x0,193
	CALL SUBOPT_0x3
; 0000 029D 
; 0000 029E                         if (at == 0) {
	TST  R7
	BRNE _0x95
; 0000 029F                         lcd_putsf("0ff ");
	__POINTW1FN _0x0,196
	CALL SUBOPT_0x3
; 0000 02A0                                      };
_0x95:
; 0000 02A1                         if (at == 10) {
	LDI  R30,LOW(10)
	CP   R30,R7
	BRNE _0x96
; 0000 02A2                         lcd_putsf("-10 ");
	__POINTW1FN _0x0,201
	CALL SUBOPT_0x3
; 0000 02A3                                      };
_0x96:
; 0000 02A4                         if (at == 20) {
	LDI  R30,LOW(20)
	CP   R30,R7
	BRNE _0x97
; 0000 02A5                         lcd_putsf("-20 ");
	__POINTW1FN _0x0,206
	CALL SUBOPT_0x3
; 0000 02A6                                       };
_0x97:
; 0000 02A7                         if (at == 30) {
	LDI  R30,LOW(30)
	CP   R30,R7
	BRNE _0x98
; 0000 02A8                         lcd_putsf("-30 ");
	__POINTW1FN _0x0,211
	CALL SUBOPT_0x3
; 0000 02A9                                       };
_0x98:
; 0000 02AA 
; 0000 02AB 
; 0000 02AC 
; 0000 02AD                         if (sig > 315)     {
	LDI  R30,LOW(315)
	LDI  R31,HIGH(315)
	CP   R30,R10
	CPC  R31,R11
	BRGE _0x99
; 0000 02AE                         lcd_putchar(0x07);
	CALL SUBOPT_0x17
; 0000 02AF                         lcd_putchar(0x00);
; 0000 02B0                         lcd_putchar(0x01);
; 0000 02B1                         lcd_putchar(0x02);
; 0000 02B2                         lcd_putchar(0x03);
; 0000 02B3                         lcd_putchar(0x04);
; 0000 02B4                         lcd_putchar(0x05);
; 0000 02B5                         lcd_putchar(0x06);
; 0000 02B6                         lcd_putchar(0x06);
; 0000 02B7                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 02B8                                           };
_0x99:
; 0000 02B9                         if (sig > 280 & sig < 315)     {
	MOVW R26,R10
	LDI  R30,LOW(280)
	LDI  R31,HIGH(280)
	CALL SUBOPT_0x19
	LDI  R30,LOW(315)
	LDI  R31,HIGH(315)
	CALL __LTW12
	AND  R30,R0
	BREQ _0x9A
; 0000 02BA                         lcd_putchar(0x07);
	CALL SUBOPT_0x17
; 0000 02BB                         lcd_putchar(0x00);
; 0000 02BC                         lcd_putchar(0x01);
; 0000 02BD                         lcd_putchar(0x02);
; 0000 02BE                         lcd_putchar(0x03);
; 0000 02BF                         lcd_putchar(0x04);
; 0000 02C0                         lcd_putchar(0x05);
; 0000 02C1                         lcd_putchar(0x06);
; 0000 02C2                         lcd_putchar(0x06);
; 0000 02C3                         lcd_putsf(" ");
	__POINTW1FN _0x0,15
	CALL SUBOPT_0x3
; 0000 02C4                                           };
_0x9A:
; 0000 02C5                         if (sig > 245 & sig < 280)     {
	MOVW R26,R10
	LDI  R30,LOW(245)
	LDI  R31,HIGH(245)
	CALL SUBOPT_0x19
	LDI  R30,LOW(280)
	LDI  R31,HIGH(280)
	CALL __LTW12
	AND  R30,R0
	BREQ _0x9B
; 0000 02C6                         lcd_putchar(0x07);
	CALL SUBOPT_0x1A
; 0000 02C7                         lcd_putchar(0x00);
; 0000 02C8                         lcd_putchar(0x01);
; 0000 02C9                         lcd_putchar(0x02);
; 0000 02CA                         lcd_putchar(0x03);
; 0000 02CB                         lcd_putchar(0x04);
; 0000 02CC                         lcd_putchar(0x05);
; 0000 02CD                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 02CE                         lcd_putsf("  ");
	__POINTW1FN _0x0,48
	CALL SUBOPT_0x3
; 0000 02CF                                           };
_0x9B:
; 0000 02D0                         if (sig > 210 & sig < 245)     {
	MOVW R26,R10
	LDI  R30,LOW(210)
	LDI  R31,HIGH(210)
	CALL SUBOPT_0x19
	LDI  R30,LOW(245)
	LDI  R31,HIGH(245)
	CALL __LTW12
	AND  R30,R0
	BREQ _0x9C
; 0000 02D1                         lcd_putchar(0x07);
	CALL SUBOPT_0x1A
; 0000 02D2                         lcd_putchar(0x00);
; 0000 02D3                         lcd_putchar(0x01);
; 0000 02D4                         lcd_putchar(0x02);
; 0000 02D5                         lcd_putchar(0x03);
; 0000 02D6                         lcd_putchar(0x04);
; 0000 02D7                         lcd_putchar(0x05);
; 0000 02D8                         lcd_putsf("   ");
	__POINTW1FN _0x0,47
	CALL SUBOPT_0x3
; 0000 02D9                                           };
_0x9C:
; 0000 02DA                         if (sig > 175 & sig < 210)     {
	MOVW R26,R10
	LDI  R30,LOW(175)
	LDI  R31,HIGH(175)
	CALL SUBOPT_0x19
	LDI  R30,LOW(210)
	LDI  R31,HIGH(210)
	CALL __LTW12
	AND  R30,R0
	BREQ _0x9D
; 0000 02DB                         lcd_putchar(0x07);
	CALL SUBOPT_0x1B
; 0000 02DC                         lcd_putchar(0x00);
; 0000 02DD                         lcd_putchar(0x01);
; 0000 02DE                         lcd_putchar(0x02);
; 0000 02DF                         lcd_putchar(0x03);
; 0000 02E0                         lcd_putchar(0x04);
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 02E1                         lcd_putsf("    ");
	__POINTW1FN _0x0,63
	CALL SUBOPT_0x3
; 0000 02E2                                           };
_0x9D:
; 0000 02E3                         if (sig > 140 & sig < 175)     {
	MOVW R26,R10
	LDI  R30,LOW(140)
	LDI  R31,HIGH(140)
	CALL SUBOPT_0x19
	LDI  R30,LOW(175)
	LDI  R31,HIGH(175)
	CALL __LTW12
	AND  R30,R0
	BREQ _0x9E
; 0000 02E4                         lcd_putchar(0x07);
	CALL SUBOPT_0x1B
; 0000 02E5                         lcd_putchar(0x00);
; 0000 02E6                         lcd_putchar(0x01);
; 0000 02E7                         lcd_putchar(0x02);
; 0000 02E8                         lcd_putchar(0x03);
; 0000 02E9                         lcd_putsf("     ");
	__POINTW1FN _0x0,216
	CALL SUBOPT_0x3
; 0000 02EA                                           };
_0x9E:
; 0000 02EB                         if (sig > 105 & sig < 140)     {
	MOVW R26,R10
	LDI  R30,LOW(105)
	LDI  R31,HIGH(105)
	CALL SUBOPT_0x19
	LDI  R30,LOW(140)
	LDI  R31,HIGH(140)
	CALL __LTW12
	AND  R30,R0
	BREQ _0x9F
; 0000 02EC                         lcd_putchar(0x07);
	CALL SUBOPT_0x1C
; 0000 02ED                         lcd_putchar(0x00);
; 0000 02EE                         lcd_putchar(0x01);
; 0000 02EF                         lcd_putchar(0x02);
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 02F0                         lcd_putsf("      ");
	__POINTW1FN _0x0,222
	CALL SUBOPT_0x3
; 0000 02F1                                           };
_0x9F:
; 0000 02F2                         if (sig > 70 & sig < 105)     {
	MOVW R26,R10
	LDI  R30,LOW(70)
	LDI  R31,HIGH(70)
	CALL SUBOPT_0x19
	LDI  R30,LOW(105)
	LDI  R31,HIGH(105)
	CALL __LTW12
	AND  R30,R0
	BREQ _0xA0
; 0000 02F3                         lcd_putchar(0x07);
	CALL SUBOPT_0x1C
; 0000 02F4                         lcd_putchar(0x00);
; 0000 02F5                         lcd_putchar(0x01);
; 0000 02F6                         lcd_putsf("       ");
	__POINTW1FN _0x0,229
	CALL SUBOPT_0x3
; 0000 02F7                                           };
_0xA0:
; 0000 02F8                         if (sig > 35 & sig < 70)     {
	MOVW R26,R10
	LDI  R30,LOW(35)
	LDI  R31,HIGH(35)
	CALL SUBOPT_0x19
	LDI  R30,LOW(70)
	LDI  R31,HIGH(70)
	CALL __LTW12
	AND  R30,R0
	BREQ _0xA1
; 0000 02F9                         lcd_putchar(0x07);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 02FA                         lcd_putchar(0x00);
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 02FB                         lcd_putsf("        ");
	__POINTW1FN _0x0,237
	CALL SUBOPT_0x3
; 0000 02FC                                           };
_0xA1:
; 0000 02FD                         if (sig >= 0 & sig < 35)     {
	MOVW R26,R10
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	CALL __GEW12
	MOV  R0,R30
	LDI  R30,LOW(35)
	LDI  R31,HIGH(35)
	CALL __LTW12
	AND  R30,R0
	BREQ _0xA2
; 0000 02FE                         lcd_putchar(0x07);
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 02FF                         lcd_putsf("         ");
	__POINTW1FN _0x0,246
	CALL SUBOPT_0x3
; 0000 0300                                           };
_0xA2:
; 0000 0301                                        };
_0x94:
; 0000 0302                         if (tx == 1) {
	SBIS 0x1E,5
	RJMP _0xA3
; 0000 0303                         lcd_gotoxy(0,1);
	CALL SUBOPT_0x11
; 0000 0304                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 0305                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 0306                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 0307                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 0308                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 0309                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 030A                         lcd_putsf("[TX]");
	__POINTW1FN _0x0,256
	CALL SUBOPT_0x3
; 0000 030B                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 030C                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 030D                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 030E                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 030F                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 0310                         lcd_putchar(0x06);
	CALL SUBOPT_0x18
; 0000 0311                                       };
_0xA3:
; 0000 0312 
; 0000 0313                         up2 = 0;
	CBI  0x1E,7
; 0000 0314                         sup = 1;
	LDI  R30,LOW(1)
	STS  _sup,R30
; 0000 0315 
; 0000 0316                         };
_0x93:
; 0000 0317 
; 0000 0318             Encoder_Exe();
	RCALL _Encoder_Exe
; 0000 0319 
; 0000 031A             if (time>10) {
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CP   R30,R12
	CPC  R31,R13
	BRGE _0xA6
; 0000 031B             ADCSRA SET_B(6);
	LDS  R30,122
	ORI  R30,0x40
	STS  122,R30
; 0000 031C             time=0;
	CLR  R12
	CLR  R13
; 0000 031D                           };
_0xA6:
; 0000 031E 
; 0000 031F        if (!SN) {
	SBIC 0x3,3
	RJMP _0xA7
; 0000 0320                         switch (shag) {
	MOVW R30,R4
; 0000 0321                         case 20: shag=1000; up1 = 1; delay_ms(300); break;
	CPI  R30,LOW(0x14)
	LDI  R26,HIGH(0x14)
	CPC  R31,R26
	BRNE _0xAB
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP _0x117
; 0000 0322                         case 1000: shag=10000; up1 = 1; delay_ms(300); break;
_0xAB:
	CPI  R30,LOW(0x3E8)
	LDI  R26,HIGH(0x3E8)
	CPC  R31,R26
	BRNE _0xAE
	LDI  R30,LOW(10000)
	LDI  R31,HIGH(10000)
	RJMP _0x117
; 0000 0323                         case 10000: shag=20; up1 = 1; delay_ms(300); break;
_0xAE:
	CPI  R30,LOW(0x2710)
	LDI  R26,HIGH(0x2710)
	CPC  R31,R26
	BRNE _0xAA
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
_0x117:
	MOVW R4,R30
	SBI  0x1E,6
	CALL SUBOPT_0xD
; 0000 0324                                     };
_0xAA:
; 0000 0325                                     };
_0xA7:
; 0000 0326        if (!ATT) {
	SBIC 0x3,1
	RJMP _0xB4
; 0000 0327                         switch (at)  {
	MOV  R30,R7
	LDI  R31,0
; 0000 0328                         case 0: at=10; up2 = 1; PORTB.4=0; PORTB.5=1; delay_ms(300); break;
	SBIW R30,0
	BRNE _0xB8
	LDI  R30,LOW(10)
	MOV  R7,R30
	SBI  0x1E,7
	CBI  0x5,4
	SBI  0x5,5
	RJMP _0x118
; 0000 0329                         case 10: at=20; up2 = 1; PORTB.4=1; PORTB.5=0; delay_ms(300); break;
_0xB8:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BRNE _0xBF
	LDI  R30,LOW(20)
	MOV  R7,R30
	SBI  0x1E,7
	SBI  0x5,4
	RJMP _0x119
; 0000 032A                         case 20: at=30; up2 = 1; PORTB.4=1; PORTB.5=1; delay_ms(300); break;
_0xBF:
	CPI  R30,LOW(0x14)
	LDI  R26,HIGH(0x14)
	CPC  R31,R26
	BRNE _0xC6
	LDI  R30,LOW(30)
	MOV  R7,R30
	SBI  0x1E,7
	SBI  0x5,4
	SBI  0x5,5
	RJMP _0x118
; 0000 032B                         case 30: at=0; up2 = 1; PORTB.4=0; PORTB.5=0; delay_ms(300); break;
_0xC6:
	CPI  R30,LOW(0x1E)
	LDI  R26,HIGH(0x1E)
	CPC  R31,R26
	BRNE _0xB7
	CLR  R7
	SBI  0x1E,7
	CBI  0x5,4
_0x119:
	CBI  0x5,5
_0x118:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	CALL SUBOPT_0x7
; 0000 032C                         };
_0xB7:
; 0000 032D                         };
_0xB4:
; 0000 032E        if (!RIT) {
	SBIC 0x3,2
	RJMP _0xD4
; 0000 032F                         switch (ri0) {
	LDI  R30,0
	SBIC 0x1E,0
	LDI  R30,1
; 0000 0330                         case 0: ri0=1; up1 = 1; delay_ms(300); lcd_clear(); up2 = 1; break;
	CPI  R30,0
	BRNE _0xD8
	SBI  0x1E,0
	SBI  0x1E,6
	RJMP _0x11A
; 0000 0331                         case 1: ri0=0; up1 = 1; ri=0; delay_ms(300); lcd_clear(); up2 = 1; break;
_0xD8:
	CPI  R30,LOW(0x1)
	BRNE _0xD7
	CBI  0x1E,0
	SBI  0x1E,6
	CLR  R8
	CLR  R9
_0x11A:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	CALL SUBOPT_0x7
	CALL _lcd_clear
	SBI  0x1E,7
; 0000 0332                         };
_0xD7:
; 0000 0333                         };
_0xD4:
; 0000 0334        if (!TXI & tx==0)        {
	LDI  R30,0
	SBIS 0x6,1
	LDI  R30,1
	MOV  R0,R30
	LDI  R26,0
	SBIC 0x1E,5
	LDI  R26,1
	LDI  R30,LOW(0)
	CALL __EQB12
	AND  R30,R0
	BREQ _0xE6
; 0000 0335                         tx=1;
	SBI  0x1E,5
; 0000 0336                         up2=1;
	SBI  0x1E,7
; 0000 0337                         };
_0xE6:
; 0000 0338        if (TXI & tx==1)
	LDI  R30,0
	SBIC 0x6,1
	LDI  R30,1
	MOV  R0,R30
	LDI  R26,0
	SBIC 0x1E,5
	LDI  R26,1
	LDI  R30,LOW(1)
	CALL __EQB12
	AND  R30,R0
	BREQ _0xEB
; 0000 0339                         {
; 0000 033A                         tx=0;
	CBI  0x1E,5
; 0000 033B                         up2=1;
	SBI  0x1E,7
; 0000 033C                         };
_0xEB:
; 0000 033D 
; 0000 033E        if (!RIT & !SN) {
	LDI  R26,0
	SBIS 0x3,2
	LDI  R26,1
	LDI  R30,0
	SBIS 0x3,3
	LDI  R30,1
	AND  R30,R26
	BREQ _0xF0
; 0000 033F                         #asm("cli");
	cli
; 0000 0340                         sfreq=freq;
	CALL SUBOPT_0x9
	LDI  R26,LOW(_sfreq)
	LDI  R27,HIGH(_sfreq)
	CALL __EEPROMWRD
; 0000 0341                         lcd_clear();
	CALL _lcd_clear
; 0000 0342                         delay_ms(1000);
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL SUBOPT_0x7
; 0000 0343                         up1=1;
	SBI  0x1E,6
; 0000 0344                         up2=2;
	SBI  0x1E,7
; 0000 0345                         #asm("sei");
	sei
; 0000 0346                         };
_0xF0:
; 0000 0347 
; 0000 0348        while (sup == 1) {   //,   
_0xF5:
	LDS  R26,_sup
	CPI  R26,LOW(0x1)
	BREQ PC+3
	JMP _0xF7
; 0000 0349                           #asm ("cli");
	cli
; 0000 034A                           if ( tx == 1 ) {                                   //    
	SBIS 0x1E,5
	RJMP _0xF8
; 0000 034B                                          f_cont = freq;                  // ,    2 (  )
	CALL SUBOPT_0x9
	RJMP _0x11B
; 0000 034C                                          } else {
_0xF8:
; 0000 034D                                          f_cont = freq+iff+ri;                // ,  
	LDS  R30,_iff
	LDS  R31,_iff+1
	LDS  R22,_iff+2
	LDS  R23,_iff+3
	LDS  R26,_freq
	LDS  R27,_freq+1
	LDS  R24,_freq+2
	LDS  R25,_freq+3
	CALL __ADDD21
	MOVW R30,R8
	CALL __CWD1
	CALL __ADDD12
_0x11B:
	STS  _f_cont,R30
	STS  _f_cont+1,R31
	STS  _f_cont+2,R22
	STS  _f_cont+3,R23
; 0000 034E                                          };
; 0000 034F 
; 0000 0350 
; 0000 0351                                          un.dataword_byte[4]=0b00000000;     //    (  )
	LDI  R30,LOW(0)
	__PUTB1MN _un,4
; 0000 0352                                          un.dataword_freq = f_cont*k;        //    
	LDS  R30,_k
	LDS  R31,_k+1
	LDS  R22,_k+2
	LDS  R23,_k+3
	LDS  R26,_f_cont
	LDS  R27,_f_cont+1
	LDS  R24,_f_cont+2
	LDS  R25,_f_cont+3
	CALL __CDF2
	CALL __MULF12
	LDI  R26,LOW(_un)
	LDI  R27,HIGH(_un)
	CALL __CFD1U
	CALL __PUTDP1
; 0000 0353 
; 0000 0354                                          FQ=1;                          //
	SBI  0xB,2
; 0000 0355                                          FQ=0;                          //  
	CBI  0xB,2
; 0000 0356 
; 0000 0357                                          for (i=0; i<5; i++)                           //
	LDI  R30,LOW(0)
	STS  _i,R30
_0xFF:
	LDS  R26,_i
	CPI  R26,LOW(0x5)
	BRSH _0x100
; 0000 0358                                                             {
; 0000 0359                                                              for(b=0; b<8; b++){
	CLR  R6
_0x102:
	LDI  R30,LOW(8)
	CP   R6,R30
	BRSH _0x103
; 0000 035A                                                              DATA = un.dataword_byte[i] & 1<<b;      //   
	LDS  R30,_i
	LDI  R31,0
	SUBI R30,LOW(-_un)
	SBCI R31,HIGH(-_un)
	LD   R1,Z
	MOV  R30,R6
	LDI  R26,LOW(1)
	CALL __LSLB12
	AND  R30,R1
	BRNE _0x104
	CBI  0xB,1
	RJMP _0x105
_0x104:
	SBI  0xB,1
_0x105:
; 0000 035B                                                              CLK = 1;                               // 
	SBI  0xB,3
; 0000 035C                                                              CLK = 0;
	CBI  0xB,3
; 0000 035D 
; 0000 035E                                                             };
	INC  R6
	RJMP _0x102
_0x103:
; 0000 035F                                                             };
	LDS  R30,_i
	SUBI R30,-LOW(1)
	STS  _i,R30
	RJMP _0xFF
_0x100:
; 0000 0360                                          DATA = 0;
	CBI  0xB,1
; 0000 0361                                          FQ=1;                                    //
	SBI  0xB,2
; 0000 0362                                          FQ=0;                                    //  
	CBI  0xB,2
; 0000 0363 
; 0000 0364                                          sup = 0;                          //     .
	LDI  R30,LOW(0)
	STS  _sup,R30
; 0000 0365                                          #asm ("sei");
	sei
; 0000 0366                           };
	RJMP _0xF5
_0xF7:
; 0000 0367 
; 0000 0368 
; 0000 0369 
; 0000 036A 
; 0000 036B 
; 0000 036C 
; 0000 036D 
; 0000 036E 
; 0000 036F 
; 0000 0370 
; 0000 0371 
; 0000 0372 
; 0000 0373 
; 0000 0374 
; 0000 0375 
; 0000 0376       }
	RJMP _0x81
; 0000 0377 }
_0x110:
	RJMP _0x110
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x01
	.EQU __sm_mask=0x0E
	.EQU __sm_adc_noise_red=0x02
	.EQU __sm_powerdown=0x04
	.EQU __sm_powersave=0x06
	.EQU __sm_standby=0x0C
	.EQU __sm_ext_standby=0x0E
	.SET power_ctrl_reg=smcr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G100:
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2000004
	SBI  0xB,5
	RJMP _0x2000005
_0x2000004:
	CBI  0xB,5
_0x2000005:
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2000006
	SBI  0x5,7
	RJMP _0x2000007
_0x2000006:
	CBI  0x5,7
_0x2000007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2000008
	SBI  0x5,6
	RJMP _0x2000009
_0x2000008:
	CBI  0x5,6
_0x2000009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x200000A
	SBI  0xB,4
	RJMP _0x200000B
_0x200000A:
	CBI  0xB,4
_0x200000B:
	__DELAY_USB 5
	SBI  0xB,6
	__DELAY_USB 13
	CBI  0xB,6
	__DELAY_USB 13
	RJMP _0x20A0001
__lcd_write_data:
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
	__DELAY_USB 133
	RJMP _0x20A0001
_lcd_write_byte:
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL __lcd_write_data
	CALL SUBOPT_0x1D
	RJMP _0x20A0003
_lcd_gotoxy:
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G100)
	SBCI R31,HIGH(-__base_y_G100)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	RCALL __lcd_write_data
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
_0x20A0003:
	ADIW R28,2
	RET
_lcd_clear:
	LDI  R30,LOW(2)
	CALL SUBOPT_0x1E
	LDI  R30,LOW(12)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(1)
	CALL SUBOPT_0x1E
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2000011
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R26,R30
	BRLO _0x2000010
_0x2000011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	ST   -Y,R30
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2000013
	RJMP _0x20A0001
_0x2000013:
_0x2000010:
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	CALL SUBOPT_0x1D
	RJMP _0x20A0001
_lcd_puts:
	ST   -Y,R17
_0x2000014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000016
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2000014
_0x2000016:
	RJMP _0x20A0002
_lcd_putsf:
	ST   -Y,R17
_0x2000017:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,1
	STD  Y+1,R30
	STD  Y+1+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000019
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x2000017
_0x2000019:
_0x20A0002:
	LDD  R17,Y+0
	ADIW R28,3
	RET
_lcd_init:
	SBI  0xA,5
	SBI  0x4,7
	SBI  0x4,6
	SBI  0xA,4
	SBI  0xA,6
	SBI  0x4,0
	SBI  0xA,7
	CBI  0xB,6
	CBI  0x5,0
	CBI  0xB,7
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G100,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G100,3
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	CALL SUBOPT_0x7
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x1F
	CALL SUBOPT_0x1F
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_write_nibble_G100
	__DELAY_USW 200
	LDI  R30,LOW(40)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(133)
	ST   -Y,R30
	RCALL __lcd_write_data
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x20A0001:
	ADIW R28,1
	RET

	.CSEG
_ltoa:
	SBIW R28,4
	ST   -Y,R17
	ST   -Y,R16
	__GETD1N 0x3B9ACA00
	__PUTD1S 2
	LDI  R16,LOW(0)
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2020003
	__GETD1S 8
	CALL __ANEGD1
	__PUTD1S 8
	CALL SUBOPT_0x20
	LDI  R30,LOW(45)
	ST   X,R30
_0x2020003:
_0x2020005:
	CALL SUBOPT_0x21
	CALL __DIVD21U
	MOV  R17,R30
	CPI  R17,0
	BRNE _0x2020008
	CPI  R16,0
	BRNE _0x2020008
	__GETD2S 2
	__CPD2N 0x1
	BRNE _0x2020007
_0x2020008:
	CALL SUBOPT_0x20
	MOV  R30,R17
	SUBI R30,-LOW(48)
	ST   X,R30
	LDI  R16,LOW(1)
_0x2020007:
	CALL SUBOPT_0x21
	CALL __MODD21U
	__PUTD1S 8
	__GETD2S 2
	CALL SUBOPT_0x14
	__PUTD1S 2
	CALL __CPD10
	BRNE _0x2020005
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,12
	RET

	.DSEG

	.CSEG

	.CSEG

	.CSEG

	.CSEG

	.DSEG
_freq:
	.BYTE 0x4
_f_cont:
	.BYTE 0x4
_iff:
	.BYTE 0x4

	.ESEG
_f_en:
	.BYTE 0x1
_eif:
	.BYTE 0x4
_ek:
	.BYTE 0x4
_fdds:
	.BYTE 0x4
_sfreq:
	.BYTE 0x4

	.DSEG
_ri_h:
	.BYTE 0x6
_fr_k:
	.BYTE 0x10
_fr_h:
	.BYTE 0x6
_fr_buf_k:
	.BYTE 0x2
_fr_buf_h:
	.BYTE 0x2
_enco_G000:
	.BYTE 0x1
_encoo_G000:
	.BYTE 0x1
_i:
	.BYTE 0x1
_sup:
	.BYTE 0x1
_un:
	.BYTE 0x5
_k:
	.BYTE 0x4
__base_y_G100:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1
__seed_G101:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x0:
	MOVW R30,R4
	LDS  R26,_freq
	LDS  R27,_freq+1
	LDS  R24,_freq+2
	LDS  R25,_freq+3
	CLR  R22
	CLR  R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x1:
	STS  _freq,R30
	STS  _freq+1,R31
	STS  _freq+2,R22
	STS  _freq+3,R23
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:45 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _lcd_gotoxy
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_putsf
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 49 TIMES, CODE SIZE REDUCTION:93 WORDS
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x4:
	LDI  R26,LOW(_fdds)
	LDI  R27,HIGH(_fdds)
	CALL __EEPROMRDD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x5:
	CALL __CDF1
	__GETD2N 0x4F800000
	CALL __DIVF21
	LDI  R26,LOW(_ek)
	LDI  R27,HIGH(_ek)
	CALL __EEPROMWRD
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x6:
	STS  124,R30
	LDS  R30,124
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 15 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x7:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x8:
	CALL _lcd_clear
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:33 WORDS
SUBOPT_0x9:
	LDS  R30,_freq
	LDS  R31,_freq+1
	LDS  R22,_freq+2
	LDS  R23,_freq+3
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0xA:
	CALL __PUTPARD1
	LDI  R30,LOW(_fr_k)
	LDI  R31,HIGH(_fr_k)
	ST   -Y,R31
	ST   -Y,R30
	CALL _ltoa
	LDI  R30,LOW(_fr_k)
	LDI  R31,HIGH(_fr_k)
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	__POINTW1FN _0x0,91
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xB:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	__POINTW1FN _0x0,95
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CP   R30,R4
	CPC  R31,R5
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	LDI  R30,LOW(300)
	LDI  R31,HIGH(300)
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0xE:
	SBI  0x1E,6
	SBI  0x1E,7
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	MOVW R4,R30
	CALL _lcd_clear
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xF:
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	CALL __PUTPARD1
	LDI  R30,LOW(_fr_k)
	LDI  R31,HIGH(_fr_k)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _ltoa

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x11:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x12:
	LDI  R30,LOW(_fr_k)
	LDI  R31,HIGH(_fr_k)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x13:
	LDS  R26,_freq
	LDS  R27,_freq+1
	LDS  R24,_freq+2
	LDS  R25,_freq+3
	__GETD1N 0x3E8
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x14:
	__GETD1N 0xA
	CALL __DIVD21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0x15:
	ST   -Y,R31
	ST   -Y,R30
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x16:
	LDI  R30,LOW(_ri_h)
	LDI  R31,HIGH(_ri_h)
	RJMP SUBOPT_0x15

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:31 WORDS
SUBOPT_0x17:
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(5)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(6)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x18:
	LDI  R30,LOW(6)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES, CODE SIZE REDUCTION:11 WORDS
SUBOPT_0x19:
	CALL __GTW12
	MOV  R0,R30
	MOVW R26,R10
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:23 WORDS
SUBOPT_0x1A:
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(3)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(5)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:15 WORDS
SUBOPT_0x1B:
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(3)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x1C:
	LDI  R30,LOW(7)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _lcd_putchar
	LDI  R30,LOW(1)
	ST   -Y,R30
	JMP  _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x1D:
	SBI  0x5,0
	LD   R30,Y
	ST   -Y,R30
	CALL __lcd_write_data
	CBI  0x5,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x1E:
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(3)
	LDI  R31,HIGH(3)
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1F:
	LDI  R30,LOW(48)
	ST   -Y,R30
	CALL __lcd_write_nibble_G100
	__DELAY_USW 200
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x20:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x21:
	__GETD1S 2
	__GETD2S 8
	RET


	.CSEG
_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__ADDD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	ADC  R23,R25
	RET

__ADDD21:
	ADD  R26,R30
	ADC  R27,R31
	ADC  R24,R22
	ADC  R25,R23
	RET

__SUBD21:
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R25,R23
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__LSLB12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	BREQ __LSLB12R
__LSLB12L:
	LSL  R30
	DEC  R0
	BRNE __LSLB12L
__LSLB12R:
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__EQB12:
	CP   R30,R26
	LDI  R30,1
	BREQ __EQB12T
	CLR  R30
__EQB12T:
	RET

__LEW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRGE __LEW12T
	CLR  R30
__LEW12T:
	RET

__GEW12:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRGE __GEW12T
	CLR  R30
__GEW12T:
	RET

__LTW12:
	CP   R26,R30
	CPC  R27,R31
	LDI  R30,1
	BRLT __LTW12T
	CLR  R30
__LTW12T:
	RET

__GTW12:
	CP   R30,R26
	CPC  R31,R27
	LDI  R30,1
	BRLT __GTW12T
	CLR  R30
__GTW12T:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__MODD21U:
	RCALL __DIVD21U
	MOVW R30,R26
	MOVW R22,R24
	RET

__PUTDP1:
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__EEPROMRDD:
	ADIW R26,2
	RCALL __EEPROMRDW
	MOVW R22,R30
	SBIW R26,2

__EEPROMRDW:
	ADIW R26,1
	RCALL __EEPROMRDB
	MOV  R31,R30
	SBIW R26,1

__EEPROMRDB:
	SBIC EECR,EEWE
	RJMP __EEPROMRDB
	PUSH R31
	IN   R31,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R30,EEDR
	OUT  SREG,R31
	POP  R31
	RET

__EEPROMWRD:
	RCALL __EEPROMWRW
	ADIW R26,2
	MOVW R0,R30
	MOVW R30,R22
	RCALL __EEPROMWRW
	MOVW R30,R0
	SBIW R26,2
	RET

__EEPROMWRW:
	RCALL __EEPROMWRB
	ADIW R26,1
	PUSH R30
	MOV  R30,R31
	RCALL __EEPROMWRB
	POP  R30
	SBIW R26,1
	RET

__EEPROMWRB:
	SBIS EECR,EEWE
	RJMP __EEPROMWRB1
	WDR
	RJMP __EEPROMWRB
__EEPROMWRB1:
	IN   R25,SREG
	CLI
	OUT  EEARL,R26
	OUT  EEARH,R27
	SBI  EECR,EERE
	IN   R24,EEDR
	CP   R30,R24
	BREQ __EEPROMWRB0
	OUT  EEDR,R30
	SBI  EECR,EEMWE
	SBI  EECR,EEWE
__EEPROMWRB0:
	OUT  SREG,R25
	RET

__CPD10:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	RET

;END OF CODE MARKER
__END_OF_CODE:
